apiVersion: kubeadm.k8s.io/v1alpha2
kind: MasterConfiguration
bootstrapTokens:
  - token: {{ token }}
    ttl: "0"
    groups:
      - system:bootstrappers:kubeadm:default-node-token
    usages:
      - signing
      - authentication
nodeRegistration:
{% if kubelet_taints|length > 0 %}
  taints:
  {% for taint in kubelet_taints %}
    - {{ taint }}
  {% endfor %}
{% endif %}
  kubeletExtraArgs:
    cloud-provider: vsphere
    cloud-config: /etc/kubernetes/cloud/cloud-config.ini
api:
  controlPlaneEndpoint: {{ kube_api_dns }}
  bindPort: 443
etcd:
  external:
    endpoints:
      - https://localhost:2379
    caFile: /etc/kubernetes/pki/etcd/ca.crt
    certFile: /etc/kubernetes/pki/apiserver-etcd-client.crt
    keyFile: /etc/kubernetes/pki/apiserver-etcd-client.key
networking:
  serviceSubnet: {{ service_cidr }}
  podSubnet: {{ pod_cidr }}
apiServerExtraArgs:
  apiserver-count: "3"
  cloud-provider: vsphere
  cloud-config: /etc/kubernetes/cloud/cloud-config.ini
controllerManagerExtraArgs:
  cloud-provider: vsphere
  cloud-config: /etc/kubernetes/cloud/cloud-config.ini
apiServerExtraVolumes:
  - name: cloud-config
    hostPath: /etc/kubernetes/cloud/
    mountPath: /etc/kubernetes/cloud/
controllerManagerExtraVolumes:
  - name: cloud-config
    hostPath: /etc/kubernetes/cloud/
    mountPath: /etc/kubernetes/cloud/
apiServerCertSANs:
{% for host in groups['master'] %}
  - {{ hostvars[host].inventory_hostname }}
{% endfor %}
  - {{ kube_api_dns }}
